//By Verite Rendition
//Alliance Fetch Builder, takes the allianceids endpoint data and prepares further ESI calls to collect the name for each alliance in order to have a complete alliance list
//This is a bit of a bruteforce method, but CCP has changed an alliance's name in the past (e.g. KenZoku). So it's easiest to just treat every day as a fresh fill of the alliance DB table
//rather than to potentially miss something
#include <iostream>
#include <string>
#include <fstream>
#include <sstream>
#include "../nlohmann/json.hpp" //Using JSON for Modern C++ 3.1.2 (single includes version)

using namespace std;

using json = nlohmann::json;

const int maxItems = 600; //Limit for /universe/names endpoint and/or the Windows CLI, whichever comes first

int main()
{
	int i, j, limit;
	unsigned int ALID, conSov;
	int sovlevel;
	int alcolor;
	//char c;
	string line, ALname, temp, alcolorstr, idNums;
	ifstream jsonFile;
	ofstream updateFile;
	int R, G, B;
	string Rstr, Gstr, Bstr;
	stringstream ss;
	json jStruct; //Create json structure

	updateFile.open("fetchAlliances.bat");

	jsonFile.open("allianceids.json"); //Open CCP alliance IDs JSON file

	if (jsonFile.is_open())
	{
		cout << "Alliance Builder Working" << endl;
	}
	else
	{
		cout << "Not Working" << endl;
		return 0;
	}

	jsonFile >> jStruct; //Read sov into json structure

	for (int i = 0; i < jStruct.size(); i+=maxItems) //Loop through alliance ID list, generate batch file to fetch true alliance info
	{
		limit = maxItems; //API limit is maxItems IDs per call
		if ((jStruct.size() - i) < maxItems) //Catch for when we have less than maxItems IDs left
			limit = jStruct.size() - i;
		idNums.clear(); //Keep a string buffer of IDs. Clear it when starting a run
		for (int j = 0; j < limit; j++) //Grab the maxItems
		{
			ALID = jStruct[i + j];
			idNums.append(std::to_string(ALID));
			idNums.append(",");
			//cout << idNums << endl;
		}
		updateFile << "curl.exe -s -k -o alliancenames" << (i / maxItems + 1) << ".json -X POST " << '"' << "https://esi.evetech.net/latest/universe/names/?datasource=tranquility" << '"' << " -H  " << '"' << "accept: application/json" << '"'
			<< " -H  " << '"' << "Content-Type: application/json" << '"' << " -d " << '"' << '[' << idNums.substr(0, idNums.length() - 1) << ']' << '"' << endl;
			
	}

	updateFile.close();
	return 0;
}	

