//By Verite Rendition
//Takes formatted sov data and builds a map of it to quickly determine what systems had their sovereignty change so that we can generate little circles for them
//ESI2 version, 12/30/2022
#include <iostream>
#include <string>
#include <fstream>
#include <map>

using namespace std;

int main()
{
	int i,j;
	int SSID;
	unsigned int ALID,ALID2;
	string line,line2;
	ifstream xml;
	ifstream xml2;
	ofstream updateFile;
	updateFile.open("updateSovChange.sql");
	xml.open("sov.txt");
	xml2.open("oldsov.txt");
	map<int,unsigned int> oldsov; //Build maps of the old and new sov data
	map<int,unsigned int> newsov;
	map<int,unsigned int>::iterator oldit;
	map<int,unsigned int>::iterator newit;
	if(xml.is_open())
	{
		cout<<"Working";
	}
	else
		cout<<"Not Working";
	updateFile<<"delete from sovchangelog;"<<endl;//Clear the old sov change log

	while(!xml.eof()) //Fill the maps
	{
		getline(xml,line);
		i=line.find(",");
		SSID = strtol(line.substr(0,i).c_str(),NULL,10);
		j=line.length()-i;
		i++;
		ALID = strtoul(line.substr(i,j).c_str(),NULL,10);
		newsov.insert(pair<int,unsigned int>(SSID,ALID));
	}
	while(!xml2.eof())
	{
		getline(xml2,line);
		i=line.find(",");
		SSID = strtol(line.substr(0,i).c_str(),NULL,10);
		j=line.length()-i;
		i++;
		ALID = strtoul(line.substr(i,j).c_str(),NULL,10);
		oldsov.insert(pair<int,unsigned int>(SSID,ALID));
	}

	newit = newsov.begin(); //Iterate through the new sov list, seeing if info for that system was in the old sov list
	while(newit!=newsov.end())
	{
		SSID=newit->first;
		ALID=newit->second;
		oldit=oldsov.find(SSID);

		if (oldit != oldsov.end()) //If the iterator doesn't match the end iterator, then we found a valid result. The same SSID is in both lists and needs to be checked to see if it changed hands
		{
			ALID2 = oldit->second;
			if (ALID2 != ALID) //Check to see if the alliance ID changed for the system. Only need to do something if it has
			{
				//cout<<"FOUND CHANGE"<<endl;
				updateFile << "insert into sovchangelog values (" << ALID2 << "," << ALID << "," << SSID << "," << "0);" << endl;
			}
		}
		else //Else the SSID was not in the old map, which indicates an unclaimed system has been claimed
		{
			updateFile << "insert into sovchangelog values (" << 0 << "," << ALID << "," << SSID << "," << "0);" << endl;
		}
		
		newit++;
	}

	oldit = oldsov.begin(); //Now go through the map again based on the old sov list, to see if any systems have dropped ownership
	while (oldit != oldsov.end())
	{
		SSID = oldit->first;
		ALID = oldit->second;
		newit = newsov.find(SSID);

		if (newit == newsov.end()) //If the iterator matches the end iterator, then we found a valid result. The same SSID is not in the new map, and ownership has been lost
		{
			updateFile << "insert into sovchangelog values (" << ALID << "," << 0 << "," << SSID << "," << "0);" << endl;
		}

		oldit++;

	}
	return 0;
}	